/***********************************************
Chip type           : ATmega128
Program type        : Application
Clock frequency     : 16.000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256

By Park Jung Hyun
www.AVRMALL.com   
Used with CodeVisionAVR Ver 1.24.2c Standard.
*********************************************/

#include <mega128.h>
#include <delay.h>
#include "am_lcd.h"
#include "am_lcd.c"
/**************************************************
  CodeVisionAVR C Compiler
  (C) 1998-2000 AVRMall, by Park Jung Hyun
  LCD functions
  
  www.avrmall.com 
***************************************************/
  
#include <mega128.h>                                      
#include <delay.h>
//#include <mem.h>

void lcd_init(void)
{
	
	delay_ms(15);
	lcd_cmd(0x38);
	
	delay_ms(5);
	lcd_cmd(0x38);
	
	delay_us(200);
	lcd_cmd(0x38);
	delay_us(100);
	
	lcd_cmd(0x38);
	delay_us(100);
	
	lcd_display_on();

	lcd_clear();
	
	lcd_cmd(0x06);
	lcd_busy();
}

void lcd_data(char data)
{
	char *lcd_io;
	lcd_busy();	
	//pokeb(0xc000, data);	//writes the byte data to SRAM at 0xc000
	//pokeb(0x9002, data);	//writes the byte data to SRAM at 0xc000
	//delay_us(10);
	lcd_io = (char *) 0x9002; 
        *lcd_io = data;
        //delay_us(10);
}

void lcd_cmd(char cmd)
{
	char *lcd_io;
	lcd_busy();	
	//pokeb(0x8000, cmd);	//writes the byte data to SRAM at 0x8000
	//pokeb(0x9000, cmd);	//writes the byte data to SRAM at 0x8000
	//delay_us(10);
	lcd_io = (char *) 0x9000; 
        *lcd_io = cmd;
        //delay_us(10);
}

char lcd_read(char read)
{	
	char *lcd_io;
	//read=peekb(0x8000); //reads a byte located in SRAM at 0x8000
	//read=peekb(0x9001); //reads a byte located in SRAM at 0x8000  
	//delay_us(10);
	lcd_io = (char *) 0x9001;
        read = *lcd_io;  
        //delay_us(10);      	
	return(read);
}
void lcd_clear(void)
{
	lcd_busy();
        lcd_cmd(0x01);
        delay_us(100);
}

void lcd_display_on(void)
{
	lcd_busy();
	lcd_cmd(0x0c);
        delay_us(100);
}

void lcd_display_off(void)
{
	lcd_busy();
	lcd_cmd(0x08);
        delay_us(100);
}

void lcd_right_shift(void)
{
	lcd_busy();
        lcd_cmd(0x1c);
        delay_us(100);
}

void lcd_left_shift(void)
{
	lcd_busy();
        lcd_cmd(0x18);
        delay_us(100);
}

void lcd_busy(void)
{
	char lcd_status;
	while(lcd_read(lcd_status) & 0x80);
}

void lcd_ch(char ch)            
{
    	char *lcd_io;
    	lcd_busy();
    	//pokeb(0xc000, ch);
    	lcd_io = (char *) 0x9002; 
        *lcd_io = ch;
}

void lcd_str(char *str)         
{
 	unsigned char i = 0;
 	do{
		lcd_ch(str[i]) ;
   	}while(str[++i] != 0x00);	//null=0x00
}

void _lcd_str(flash char *str)
{
	unsigned char i = 0;
 	do{
		lcd_ch(str[i]) ;
   	}while(str[++i] != 0x00);	//null=0x00
}

void Gotoxy(unsigned char x, unsigned char y)	//x-  y |
{
    lcd_busy();
    switch(y)
    {
       case 0: lcd_cmd(0x80+x); break;  
       case 1: lcd_cmd(0xc0+x); break;
       case 2: lcd_cmd(0x94+x); break;
       case 3: lcd_cmd(0xd4+x); break;	
    }
	
}
//#include <lcd.h>

void main(void)
{
        ////////////////////////lcd out string
        //char lcd_buff[]="::AVRMall::";
        //char lcd_buff_1[]="Mega128 LCD Test";
        //////////////////////////////////////
        
        MCUCR=0xc0;
	#asm("sei");
	
	lcd_init();
	
	while(1)
	{
		Gotoxy(1,0);
		_lcd_str("** AVRMALL **");
	
		Gotoxy(0,1);
		_lcd_str("M128KIT V2.0 LCD"); 
		/*	
		lcd_display_on();
		delay_ms(300);
		lcd_display_off();
		delay_ms(300);
		lcd_display_on();
		delay_ms(300);
	        	
		delay_ms(500);delay_ms(500);      
	        	
		lcd_right_shift();
		lcd_right_shift();
		delay_ms(500);delay_ms(500);
	        	
		lcd_left_shift();
		lcd_left_shift(); 
		lcd_left_shift();
		lcd_left_shift();
		delay_ms(500);
	               	
		lcd_right_shift();
		lcd_right_shift();    
                */
	}
}
